# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::TimeSeriesInsights::Mgmt::V2018_08_15_preview
  module Models
    #
    # Properties of the environment.
    #
    class EnvironmentResourceProperties < ResourceProperties

      include MsRestAzure

      # @return An id used to access the environment data, e.g. to query the
      # environment's events or upload reference data for the environment.
      attr_accessor :data_access_id

      # @return [String] The fully qualified domain name used to access the
      # environment data, e.g. to query the environment's events or upload
      # reference data for the environment.
      attr_accessor :data_access_fqdn

      # @return [EnvironmentStatus] An object that represents the status of the
      # environment, and its internal state in the Time Series Insights
      # service.
      attr_accessor :status


      #
      # Mapper for EnvironmentResourceProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EnvironmentResourceProperties',
          type: {
            name: 'Composite',
            class_name: 'EnvironmentResourceProperties',
            model_properties: {
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              creation_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'creationTime',
                type: {
                  name: 'DateTime'
                }
              },
              data_access_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'dataAccessId',
                type: {
                  name: 'String'
                }
              },
              data_access_fqdn: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'dataAccessFqdn',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'Composite',
                  class_name: 'EnvironmentStatus'
                }
              }
            }
          }
        }
      end
    end
  end
end
