# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::TimeSeriesInsights::Mgmt::V2018_08_15_preview
  module Models
    #
    # Parameters supplied to the Create or Update Environment operation for a
    # long-term environment.
    #
    class LongTermEnvironmentCreateOrUpdateParameters < EnvironmentCreateOrUpdateParameters

      include MsRestAzure


      def initialize
        @kind = "LongTerm"
      end

      attr_accessor :kind

      # @return [Array<TimeSeriesIdProperty>] The list of event properties
      # which will be used to define the environment's time series id.
      attr_accessor :time_series_id_properties

      # @return [LongTermStorageConfigurationInput] The storage configuration
      # provides the connection details that allows the Time Series Insights
      # service to connect to the customer storage account that is used to
      # store the environment's data.
      attr_accessor :storage_configuration

      # @return [Duration] ISO8601 timespan specifying the number of days the
      # environment's events will be available for query from the warm store.
      attr_accessor :data_retention


      #
      # Mapper for LongTermEnvironmentCreateOrUpdateParameters class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LongTerm',
          type: {
            name: 'Composite',
            class_name: 'LongTermEnvironmentCreateOrUpdateParameters',
            model_properties: {
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              sku: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              time_series_id_properties: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.timeSeriesIdProperties',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TimeSeriesIdPropertyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TimeSeriesIdProperty'
                      }
                  }
                }
              },
              storage_configuration: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.storageConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'LongTermStorageConfigurationInput'
                }
              },
              data_retention: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.warmStoreConfiguration.dataRetention',
                type: {
                  name: 'TimeSpan'
                }
              }
            }
          }
        }
      end
    end
  end
end
